diff mbox series

[net-next,2/2] selftests: fib_nexthops: Test large scale nexthop flushing

Message ID 20210416155535.1694714-3-idosch@idosch.org
State New
Headers show
Series nexthop: Support large scale nexthop flushing | expand

Commit Message

Ido Schimmel April 16, 2021, 3:55 p.m. UTC
From: Ido Schimmel <idosch@nvidia.com>

Test that all the nexthops are flushed when a multi-part nexthop dump is
required for the flushing.

Without previous patch:

 # ./fib_nexthops.sh
 TEST: Large scale nexthop flushing                                  [FAIL]

With previous patch:

 # ./fib_nexthops.sh
 TEST: Large scale nexthop flushing                                  [ OK ]

Signed-off-by: Ido Schimmel <idosch@nvidia.com>
Reviewed-by: Petr Machata <petrm@nvidia.com>
---
 tools/testing/selftests/net/fib_nexthops.sh | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

Comments

David Ahern April 18, 2021, 5:07 p.m. UTC | #1
On 4/16/21 8:55 AM, Ido Schimmel wrote:
> From: Ido Schimmel <idosch@nvidia.com>

> 

> Test that all the nexthops are flushed when a multi-part nexthop dump is

> required for the flushing.

> 

> Without previous patch:

> 

>  # ./fib_nexthops.sh

>  TEST: Large scale nexthop flushing                                  [FAIL]

> 

> With previous patch:

> 

>  # ./fib_nexthops.sh

>  TEST: Large scale nexthop flushing                                  [ OK ]

> 

> Signed-off-by: Ido Schimmel <idosch@nvidia.com>

> Reviewed-by: Petr Machata <petrm@nvidia.com>

> ---

>  tools/testing/selftests/net/fib_nexthops.sh | 15 +++++++++++++++

>  1 file changed, 15 insertions(+)

> 


Reviewed-by: David Ahern <dsahern@kernel.org>
diff mbox series

Patch

diff --git a/tools/testing/selftests/net/fib_nexthops.sh b/tools/testing/selftests/net/fib_nexthops.sh
index 56dd0c6f2e96..49774a8a7736 100755
--- a/tools/testing/selftests/net/fib_nexthops.sh
+++ b/tools/testing/selftests/net/fib_nexthops.sh
@@ -1933,6 +1933,21 @@  basic()
 	log_test $? 2 "Nexthop group and blackhole"
 
 	$IP nexthop flush >/dev/null 2>&1
+
+	# Test to ensure that flushing with a multi-part nexthop dump works as
+	# expected.
+	local batch_file=$(mktemp)
+
+	for i in $(seq 1 $((64 * 1024))); do
+		echo "nexthop add id $i blackhole" >> $batch_file
+	done
+
+	$IP -b $batch_file
+	$IP nexthop flush >/dev/null 2>&1
+	[[ $($IP nexthop | wc -l) -eq 0 ]]
+	log_test $? 0 "Large scale nexthop flushing"
+
+	rm $batch_file
 }
 
 check_nexthop_buckets_balance()